﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace EziMOTIONTest
{
    public partial class Form1 : Form
    {
        byte m_nPortNo;
        bool m_bConnected;

        public Form1()
        {
            InitializeComponent();

            m_nPortNo = 0;
            m_bConnected = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            /*
            int nRtn = FAS_EziMOTIONPlusR.FAS_MoveStop(1, 1);

            if (nRtn == FAS_EziMOTIONPlusR.FMM_OK)
            {
            }
             */

            textPortNo.Text = "1";
            comboBaudrate.SelectedIndex = 4;    // default baudrate: 115200 

            textPosition.Text = "10000";
            textSpeed.Text = "10000";
        }

        private void buttonConnect_Click(object sender, EventArgs e)
        {
            if (textPortNo.Text.Length <= 0)
            {
                textPortNo.Focus();
                return;
            }

            if (m_bConnected == false)
            {
                uint dwBaud;

                m_nPortNo = byte.Parse(textPortNo.Text);
                dwBaud = uint.Parse(comboBaudrate.Text);

                if (FAS_EziMOTIONPlusR.FAS_Connect(m_nPortNo, dwBaud) == 0)
                {
                    // Failed to connect
                    MessageBox.Show("Failed to connect");
                }
                else
                {
                    // connected.
                    m_bConnected = true;

                    buttonConnect.Text = "Disconnect";
                    textPortNo.ReadOnly = true;
                    comboBaudrate.Enabled = false;

                    for (byte i = 0; i < FAS_EziMOTIONPlusR.MAX_SLAVE_NUMS; i++)
                    {
                        if (FAS_EziMOTIONPlusR.FAS_IsSlaveExist(m_nPortNo, i) != 0)
                        {
                            textSlaveNo.Text = i.ToString();
                            break;
                        }
                    }
                }
            }
            else
            {
                FAS_EziMOTIONPlusR.FAS_Close(m_nPortNo);
                m_bConnected = false;

                buttonConnect.Text = "Connect";
                textPortNo.ReadOnly = false;
                comboBaudrate.Enabled = true;
            }
        }

        private void buttonMoveDEC_Click(object sender, EventArgs e)
        {
            byte iSlaveNo;
            int nRtn;
            int lPosition;
            uint lVelocity;

            if (m_bConnected == false)
                return;

            if (textSlaveNo.Text.Length <= 0)
            {
                textSlaveNo.Focus();
                return;
            }

            iSlaveNo = byte.Parse(textSlaveNo.Text);

            lPosition = int.Parse(textPosition.Text);
            lVelocity = uint.Parse(textSpeed.Text);

            nRtn = FAS_EziMOTIONPlusR.FAS_MoveSingleAxisIncPos(m_nPortNo, iSlaveNo, lPosition * -1, lVelocity);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_MoveSingleAxisIncPos() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
            }
        }

        private void buttonMoveINC_Click(object sender, EventArgs e)
        {
            byte iSlaveNo;
            int nRtn;
            int lPosition;
            uint lVelocity;

            if (m_bConnected == false)
                return;

            if (textSlaveNo.Text.Length <= 0)
            {
                textSlaveNo.Focus();
                return;
            }

            iSlaveNo = byte.Parse(textSlaveNo.Text);

            lPosition = int.Parse(textPosition.Text);
            lVelocity = uint.Parse(textSpeed.Text);

            nRtn = FAS_EziMOTIONPlusR.FAS_MoveSingleAxisIncPos(m_nPortNo, iSlaveNo, lPosition, lVelocity);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_MoveSingleAxisIncPos() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
            }
        }

        private void buttonMoveABS_Click(object sender, EventArgs e)
        {
            byte iSlaveNo;
            int nRtn;
            int lPosition;
            uint lVelocity;

            if (m_bConnected == false)
                return;

            if (textSlaveNo.Text.Length <= 0)
            {
                textSlaveNo.Focus();
                return;
            }

            iSlaveNo = byte.Parse(textSlaveNo.Text);

            lPosition = int.Parse(textPosition.Text);
            lVelocity = uint.Parse(textSpeed.Text);

            nRtn = FAS_EziMOTIONPlusR.FAS_MoveSingleAxisAbsPos(m_nPortNo, iSlaveNo, lPosition, lVelocity);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_MoveSingleAxisAbsPos() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
            }
        }

        private void buttonAlarmReset_Click(object sender, EventArgs e)
        {
            byte iSlaveNo;
            int nRtn;

            if (m_bConnected == false)
                return;

            if (textSlaveNo.Text.Length <= 0)
            {
                textSlaveNo.Focus();
                return;
            }

            iSlaveNo = byte.Parse(textSlaveNo.Text);

            nRtn = FAS_EziMOTIONPlusR.FAS_ServoAlarmReset(m_nPortNo, iSlaveNo);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_ServoAlarmReset() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
            }
        }

        private void buttonServoON_Click(object sender, EventArgs e)
        {
            byte iSlaveNo;
            int nRtn;

            if (m_bConnected == false)
                return;

            if (textSlaveNo.Text.Length <= 0)
            {
                textSlaveNo.Focus();
                return;
            }

            iSlaveNo = byte.Parse(textSlaveNo.Text);

            nRtn = FAS_EziMOTIONPlusR.FAS_ServoEnable(m_nPortNo, iSlaveNo, 1);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_ServoEnable() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
            }
        }

        private void buttonSTOP_Click(object sender, EventArgs e)
        {
            byte iSlaveNo;
            int nRtn;

            if (m_bConnected == false)
                return;

            if (textSlaveNo.Text.Length <= 0)
            {
                textSlaveNo.Focus();
                return;
            }

            iSlaveNo = byte.Parse(textSlaveNo.Text);

            nRtn = FAS_EziMOTIONPlusR.FAS_MoveStop(m_nPortNo, iSlaveNo);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_MoveStop() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
            }
        }

        private void buttonMotionTest_Click(object sender, EventArgs e)
        {
            // TODO:
            // reset alarm if there is alarm.
            // enable drive if servo off status.
            // and wait until servo on status.

            // move to 10000 pulse.
            // move to -20000 pulse when first motion is finished.

            byte iSlaveNo;
            uint dwAxisStatus = 0;
            int lPosition;
            uint lVelocity = 10000;
            int lCmdPos = 0;
            int nRtn;

            if (m_bConnected == false)
                return;

            if (textSlaveNo.Text.Length <= 0)
            {
                textSlaveNo.Focus();
                return;
            }

            iSlaveNo = byte.Parse(textSlaveNo.Text);

            nRtn = FAS_EziMOTIONPlusR.FAS_GetAxisStatus(m_nPortNo, iSlaveNo, ref dwAxisStatus);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_GetAxisStatus() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
                return;
            }

            // reset alarm if there is alarm.
            if ((dwAxisStatus & EziSERVOPlusR.FFLAG_ERRORALL) != 0) // FFLAG_ERRORALL is ON
            {
                nRtn = FAS_EziMOTIONPlusR.FAS_ServoAlarmReset(m_nPortNo, iSlaveNo);
                if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
                {
                    string strMsg;
                    strMsg = "FAS_ServoAlarmReset() \nReturned: " + nRtn.ToString();
                    MessageBox.Show(strMsg, "Function Failed");
                    return;
                }
            }

            // enable drive if servo off status.
            if ((dwAxisStatus & EziSERVOPlusR.FFLAG_SERVOON) == 0)  // FFLAG_SERVOON is OFF
            {
                nRtn = FAS_EziMOTIONPlusR.FAS_ServoEnable(m_nPortNo, iSlaveNo, 1);
                if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
                {
                    string strMsg;
                    strMsg = "FAS_ServoEnable() \nReturned: " + nRtn.ToString();
                    MessageBox.Show(strMsg, "Function Failed");
                    return;
                }
            }

            // and wait until servo on status.
            do
            {
                nRtn = FAS_EziMOTIONPlusR.FAS_GetAxisStatus(m_nPortNo, iSlaveNo, ref dwAxisStatus);
                if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
                {
                    string strMsg;
                    strMsg = "FAS_GetAxisStatus() \nReturned: " + nRtn.ToString();
                    MessageBox.Show(strMsg, "Function Failed");
                    return;
                }

                if ((dwAxisStatus & EziSERVOPlusR.FFLAG_ERRORALL) == 1)  // FFLAG_ERRORALL is ON
                {
                    string strMsg;
                    strMsg = "Error flag";
                    MessageBox.Show(strMsg, "AxisStatus");
                    return;
                }
            }
            while ((dwAxisStatus & EziSERVOPlusR.FFLAG_SERVOON) == 0);  // FFLAG_SERVOON is OFF

            // move to 10000 pulse.
            lPosition = 10000;
            nRtn = FAS_EziMOTIONPlusR.FAS_MoveSingleAxisAbsPos(m_nPortNo, iSlaveNo, lPosition, lVelocity);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_MoveSingleAxisIncPos() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
                return;
            }

            // WAIT
            do
            {
                nRtn = FAS_EziMOTIONPlusR.FAS_GetAxisStatus(m_nPortNo, iSlaveNo, ref dwAxisStatus);
                if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
                {
                    string strMsg;
                    strMsg = "FAS_GetAxisStatus() \nReturned: " + nRtn.ToString();
                    MessageBox.Show(strMsg, "Function Failed");
                    return;
                }

                if ((dwAxisStatus & EziSERVOPlusR.FFLAG_ERRORALL) == 1)  // FFLAG_ERRORALL is ON
                {
                    string strMsg;
                    strMsg = "Error flag";
                    MessageBox.Show(strMsg, "AxisStatus");
                    return;
                }
            }
            while ((dwAxisStatus & EziSERVOPlusR.FFLAG_MOTIONING) != 0);  // FFLAG_MOTIONING is ON

            // check position
            nRtn = FAS_EziMOTIONPlusR.FAS_GetCommandPos(m_nPortNo, iSlaveNo, ref lCmdPos);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_GetCommandPos() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
                return;
            }

            if (lCmdPos != lPosition)
            {
                string strMsg;
                strMsg = "Wrong position \nCurrent Position: " + lCmdPos.ToString();
                MessageBox.Show(strMsg, "Error");
                return;
            }

            // move to -20000 pulse when first motion is finished.
            lPosition = -20000;
            nRtn = FAS_EziMOTIONPlusR.FAS_MoveSingleAxisIncPos(m_nPortNo, iSlaveNo, lPosition, lVelocity);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_MoveSingleAxisIncPos() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
                return;
            }

            // WAIT
            do
            {
                nRtn = FAS_EziMOTIONPlusR.FAS_GetAxisStatus(m_nPortNo, iSlaveNo, ref dwAxisStatus);
                if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
                {
                    string strMsg;
                    strMsg = "FAS_GetAxisStatus() \nReturned: " + nRtn.ToString();
                    MessageBox.Show(strMsg, "Function Failed");
                    return;
                }

                if ((dwAxisStatus & EziSERVOPlusR.FFLAG_ERRORALL) == 1)  // FFLAG_ERRORALL is ON
                {
                    string strMsg;
                    strMsg = "Error flag";
                    MessageBox.Show(strMsg, "AxisStatus");
                    return;
                }
            }
            while ((dwAxisStatus & EziSERVOPlusR.FFLAG_MOTIONING) != 0);  // FFLAG_MOTIONING is ON

            // check position
            nRtn = FAS_EziMOTIONPlusR.FAS_GetCommandPos(m_nPortNo, iSlaveNo, ref lCmdPos);
            if (nRtn != FAS_EziMOTIONPlusR.FMM_OK)
            {
                string strMsg;
                strMsg = "FAS_GetCommandPos() \nReturned: " + nRtn.ToString();
                MessageBox.Show(strMsg, "Function Failed");
                return;
            }

            if (lCmdPos != lPosition)
            {
                string strMsg;
                strMsg = "Wrong position \nCurrent Position: " + lCmdPos.ToString();
                MessageBox.Show(strMsg, "Error");
                return;
            }

            MessageBox.Show("Finished");
        }
    }
}
